Require Import MetricCore.

Section Streams.
  Context T `{cmT : cmetric T}.

  Definition stream := nat -> T.
  Definition eq_s (xs ys : stream) := forall n, xs n == ys n.
  Global Program Instance stream_eqt : Setoid stream := mkType eq_s.
  Next Obligation.
    split.
    - intros s n; reflexivity.
    - intros xs ys HS n; symmetry; apply HS.
    - intros xs ys zs Hxy Hyz n; etransitivity; [apply Hxy | apply Hyz].
  Qed.

  Definition dist_s n (xs ys : stream) := forall m (HLt : m < n), xs m = n = ys m.
  Global Program Instance stream_metr : metric stream := mkMetr dist_s.
  Next Obligation.
    intros xs1 xs2 EQxs ys1 ys2 EQys; split; intros Dxy m HLt.
    - rewrite <- (EQxs m), <- (EQys m); apply Dxy, HLt.
    - rewrite (EQxs m), (EQys m); apply Dxy, HLt.
  Qed.
  Next Obligation.
    split; [intros HD n | intros HE n m HLt].
    - rewrite <- dist_refl; intros m.
      apply mono_dist with (S (max m n)); [now auto with arith |].
      apply HD; now auto with arith.
    - rewrite (HE m); reflexivity.
  Qed.
  Next Obligation.
    intros xs ys Dxy m HLt; symmetry; auto.
  Qed.
  Next Obligation.
    intros xs ys zs Hxy Dyz m HLt; etransitivity; eauto.
  Qed.
  Next Obligation.
    intros m HLt; apply dist_mono, H; auto with arith.
  Qed.
  Next Obligation.
    intros m HLt; now inversion HLt.
  Qed.


